/**
 * UDP Simple Client ist ein kleines Netzwerktool auf  Basis des TCP Protokolls
 * Quelle http://www.wut.de
 */
import java.net.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.Timer;


public class WebIO_Binary_Client_2_2 extends JFrame implements ActionListener,KeyListener,Runnable{
	//Allgemein
	private static final long serialVersionUID = -6061394082201596541L;
	final int inputs = 2;
	final int outputs = 2;
	private Container co;
	private JPanel jp[] = new JPanel[2];
	private JTextField tf_statusbar = new JTextField();
	private Timer timer;
	
	//12 Zeilen fr IO-Elemente
	private JCheckBox cb_outputs[] = new JCheckBox[outputs];
	private JCheckBox cb_inputs[] = new JCheckBox[inputs];
	private JLabel lb_counter[] = new JLabel[inputs];
	private JButton bt_read[] = new JButton[inputs];
	private JButton bt_clear[] = new JButton[inputs];
	private JTextField tf_counter[] = new JTextField[inputs];
	
	//"all" Zeile
	private JLabel lb_countall = new JLabel("all Counter ->");
	private JButton bt_all[] = new JButton[4];
	
	// polling Zeile
	private JCheckBox cb_polling[] = new JCheckBox[3];
	private JTextField tf_pollingtime = new JTextField("250");
	private JLabel lb_polling = new JLabel("Intervall");
	
	//Connection Teil
	private JTextField tf_ip = new JTextField();
	private JTextField tf_port = new JTextField("49153");
	private JLabel lb_connection[] = new JLabel[3];
	private JButton bt_connect = new JButton("Connect");
	private JButton bt_disconnect = new JButton("Disconnect");
	private Socket socket;
	private OutputStream out;
	private InputStream in;
	
	
	public WebIO_Binary_Client_2_2(String name){
		//Allgemein JFrame Eigentschaften
		super(name);
		this.setLocation(300,300);
		this.setSize(413,240);
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		co = getContentPane();
		co.setLayout(null);
		jp[0] = new JPanel(null);
		jp[1] = new JPanel(null);
		jp[0].setBorder(new TitledBorder("Input/Output Control"));
		jp[1].setBorder(new TitledBorder("Connection Control"));
		jp[0].setBounds(2, 5, 395, 125);
		jp[1].setBounds(2, 130, 395, 50);
		tf_statusbar.setBounds(2,185,395,20);
		tf_statusbar.setEditable(false);
		tf_statusbar.setText("No Connection");
		co.add(tf_statusbar);
		co.add(jp[0]);
		co.add(jp[1]);
		
		//12xIO Zeilen
		for(int i=0;i<outputs;i++){
			cb_outputs[i] =  new JCheckBox("Output "+i);
			cb_outputs[i].setBounds(3, 20+(i*20), 80, 15);
			cb_outputs[i].addActionListener(this);
			jp[0].add(cb_outputs[i]);
		}
		for(int i=0;i<inputs;i++){
			cb_inputs[i] =  new JCheckBox("Input "+i);
			lb_counter[i] = new JLabel("Counter "+i);
			tf_counter[i] = new JTextField();
			bt_read[i]= new JButton("read");
			bt_clear[i]= new JButton("clear");

			
			cb_inputs[i].setBounds(80, 20+(i*20), 70, 15);
			lb_counter[i].setBounds(150, 20+(i*20), 65, 15);
			tf_counter[i].setBounds(215, 19+(i*20), 50, 18);
			bt_read[i].setBounds(265, 20+(i*20), 60, 15);
			bt_clear[i].setBounds(325, 20+(i*20), 65, 15);
			
			tf_counter[i].setText("0");
			tf_counter[i].setHorizontalAlignment(JTextField.CENTER);
			bt_read[i].addActionListener(this);
			bt_clear[i].addActionListener(this);
			
			cb_inputs[i].setEnabled(false);
			
			
			jp[0].add(cb_inputs[i]);
			jp[0].add(lb_counter[i]);
			jp[0].add(tf_counter[i]);
			jp[0].add(bt_read[i]);
			jp[0].add(bt_clear[i]);
		}
		
		//"all" Zeile
		String[] s = {"read all","read all","read","clear"};
		for(int i=0;i<=3;i++){
			bt_all[i]= new JButton(s[i]);
			bt_all[i].addActionListener(this);
			jp[0].add(bt_all[i]);
		}
		jp[0].add(lb_countall);
		bt_all[0].setBounds(2, 70, 76, 15);
		bt_all[1].setBounds(76, 70, 76, 15);
		lb_countall.setBounds(165, 70, 76, 15);
		bt_all[2].setBounds(265, 70, 60, 15);
		bt_all[3].setBounds(325, 70, 65, 15);
		
		//polling Zeile
		for(int i=0;i<3;i++){
			cb_polling[i] = new JCheckBox("polling");
			jp[0].add(cb_polling[i]);
		}
		jp[0].add(tf_pollingtime);
		jp[0].add(lb_polling);
		tf_pollingtime.addKeyListener(this);
		tf_pollingtime.setBounds(215, 100, 50, 18);
		lb_polling.setBounds(165, 100, 50, 18);
		cb_polling[0].setBounds(3, 100, 80, 15);
		cb_polling[1].setBounds(80, 100, 80, 15);
		cb_polling[2].setBounds(265, 100, 80, 15);
		
		
		//Connection Teil
		jp[1].add(tf_ip);
		jp[1].add(tf_port);
		jp[1].add(bt_connect);
		jp[1].add(bt_disconnect);
		
		tf_ip.setBounds(15,30,100,15);
		tf_port.setBounds(125,30,50,15);
		bt_connect.setBounds(288,30,100,15);
		bt_disconnect.setBounds(288,15,100,15);
		
		bt_connect.addActionListener(this);
		bt_disconnect.addActionListener(this);
		
		String[] s2 = {"IP","Port"};
		for(int i=0;i<=1;i++){
			lb_connection[i]= new JLabel(s2[i]);
			jp[1].add(lb_connection[i]);	
		}
		lb_connection[0].setBounds(15,15,100,15);
		lb_connection[1].setBounds(125,15,50,15);
		
		//disconnect() deaktiviert alle nicht verfgbaren Elmente
		this.disconnect();
		//den JFrame sichtbar machen nachdem alle Elmente initialisiert sind
		this.setVisible(true);
		
	}
	public void actionPerformed(ActionEvent ev){
		byte[] byte_array = new byte[16];
		Integer struct_type[]= new Integer[2];
		byte length[]= new byte[2];
		
		if(ev.getSource()== bt_all[0] || (ev.getSource()== timer && cb_polling[0].isSelected())){
			//structure "RegisterRequest"
			struct_type[0] = 0x00;
			struct_type[1] = 0x21;
			length[0] = 0x00;
			length[1] = 0x08;
			this.sendStructure(byte_array, struct_type, length);
		}
		if(ev.getSource()== bt_all[1] || ( ev.getSource()== timer && cb_polling[1].isSelected())){
			//structure "ReadRegister"
			struct_type[0] = 0x00;
			struct_type[1] = 0x01;
			length[0] = 0x00;
			length[1] = 0x08;
			this.sendStructure(byte_array, struct_type, length);
		}
		if(ev.getSource()== bt_all[2] || (ev.getSource()== timer && cb_polling[2].isSelected())){
			//structure "ReadAllCounter"
			struct_type[0] = 0x00;
			struct_type[1] = 0xB1;
			length[0] = 0x00;
			length[1] = 0x08;
			this.sendStructure(byte_array, struct_type, length);
		}
		
		if(ev.getActionCommand()=="Connect"){
			this.connect();	
		}else if(ev.getActionCommand()=="Disconnect"){
			this.disconnect();
		}else if(ev.getSource()== bt_all[3]){
			//structure "ReadClearAllCounter"
			struct_type[0] = 0x00;
			struct_type[1] = 0xC1;
			length[0] = 0x00;
			length[1] = 0x08;
			this.sendStructure(byte_array, struct_type, length);
		}else{
			for(int i=0;i<inputs;i++){
				if(ev.getSource() == bt_read[i]){
					//structure "ReadCounter"
					Integer counter_index[] = new Integer[2];
					struct_type[0] = 0x00;
					struct_type[1] = 0xB0;
					length[0] = 0x00;
					length[1] = 0x0A;
					counter_index[0]=0x00;
					counter_index[1]=i;
					byte_array[8] = counter_index[1].byteValue();
					byte_array[9] = counter_index[0].byteValue();
					this.sendStructure(byte_array, struct_type, length);
				}else if(ev.getSource() == bt_clear[i]){
					//structure "ReadClearCounter"
					Integer counter_index[] = new Integer[2];
					struct_type[0] = 0x00;
					struct_type[1] = 0xC0;
					length[0] = 0x00;
					length[1] = 0x0A;
					counter_index[0]=0x00;
					counter_index[1]=i;
					byte_array[8] = counter_index[1].byteValue();
					byte_array[9] = counter_index[0].byteValue();
					this.sendStructure(byte_array, struct_type, length);
				}else if(i<outputs && ev.getSource() == cb_outputs[i]){
					//structure "SetBit"
					Integer set_bits[]= new Integer[2];
					Integer value[]= new Integer[2];
					length[0] = 0x00;
					length[1] = 0x0C;
					struct_type[0] = 0x00;
					struct_type[1] = 0x09;
					set_bits[0] = 0x00;
					set_bits[1] = 0x00;
					value[0] = 0x00;
					value[1] = 0x00;
					if(!cb_outputs[i].isSelected()){
						if(i<8){ 
							set_bits[0]=(int)Math.pow(2,i);
						}else {   
							set_bits[1]=(int)Math.pow(2,i-8);
						}						
					}else{
						if(i<8){ 
							set_bits[0]=(int)Math.pow(2,i);
							value[0] =(int)Math.pow(2,i);
						}else {   
							set_bits[1]=(int)Math.pow(2,i-8);
							value[1] =(int)Math.pow(2,i-8);
						}
					}
					byte_array[8] = set_bits[0].byteValue();
					byte_array[9] = set_bits[1].byteValue();
					byte_array[10] = value[0].byteValue();
					byte_array[11] = value[1].byteValue();
					this.sendStructure(byte_array, struct_type, length);
				}
			} 
			
		}
	}
	
	public void sendStructure(byte[] byte_array,Integer[] struct_type,byte[] length){
		byte send_sequenz[] = new byte[2];
		byte rec_sequenz[] = new byte[2];
		
		//send_sequenz und rec_sequenz sind immer 0 
		send_sequenz[0] = 0x00;
		send_sequenz[1] = 0x00;
		rec_sequenz[0] = 0x00;
		rec_sequenz[1] = 0x00;
		
		byte_array[0]=send_sequenz[1];
		byte_array[1]=send_sequenz[0];
		byte_array[2]=rec_sequenz[1];
		byte_array[3]=rec_sequenz[0];
		
		byte_array[4] = struct_type[1].byteValue();
		byte_array[5] = struct_type[0].byteValue();
		byte_array[6] = length[1];
		byte_array[7] = length[0];
		try{
			out.write(byte_array,0,length[1]);
			out.flush();
		}catch(IOException ex){
		}
	}
	
	public void keyPressed(KeyEvent ev) {
	}
	public void keyReleased(KeyEvent ev) {
	  try {
	    timer.setDelay(Integer.parseInt(tf_pollingtime.getText()));
	  } catch (NumberFormatException e) {
	  }
	}
	public void keyTyped(KeyEvent ev) {
	}
	public void connect(){
		if(!tf_ip.getText().isEmpty() && !tf_port.getText().isEmpty()){
			try{
				int port = Integer.parseInt( tf_port.getText());
				socket = new Socket(tf_ip.getText(),port);
				out = socket.getOutputStream();			
				in = socket.getInputStream();
				timer = new Timer(Integer.parseInt(tf_pollingtime.getText()), this);
				timer.start();
				//Theard welcher die Einkommende-Kommunikation abhandelt
				new Thread(this).start();
				
				bt_connect.setEnabled(false);
				bt_disconnect.setEnabled(true);
				tf_ip.setEditable(false);
				tf_port.setEditable(false);
				for(int i=0;i<4;i++){
					if(i<=1) bt_read[i].setEnabled(true);
					if(i<=1) bt_clear[i].setEnabled(true);
					if(i<=1) lb_counter[i].setEnabled(true);
					if(i<outputs)cb_outputs[i].setEnabled(true);
					if(i<=3) bt_all[i].setEnabled(true);
					if(i<=2) cb_polling[i].setEnabled(true);
				}
				tf_pollingtime.setEnabled(true);
				lb_polling.setEnabled(true);
				lb_countall.setEnabled(true);
				tf_statusbar.setText("Connected to "+tf_ip.getText());
			}catch(IOException e){
				tf_statusbar.setText("error: "+e.getMessage());
			}
		}
	}
	public void disconnect(){
		try{
			if(timer != null)  timer.stop();
			if(socket != null){
				socket.close();
			}
			bt_connect.setEnabled(true);
			bt_disconnect.setEnabled(false);
			tf_ip.setEditable(true);
			tf_port.setEditable(true);
			for(int i=0;i<4;i++){
				if(i<=1) bt_read[i].setEnabled(false);
				if(i<=1) bt_clear[i].setEnabled(false);
				if(i<=1) lb_counter[i].setEnabled(false);
				
				if(i<=3) bt_all[i].setEnabled(false);
				if(i<=2) cb_polling[i].setEnabled(false);
				if(i<outputs) cb_outputs[i].setEnabled(false);
			}
			
			tf_pollingtime.setEnabled(false);
			lb_polling.setEnabled(false);
			lb_countall.setEnabled(false);
			tf_statusbar.setText("No Connection");
		}catch(IOException e){
			tf_statusbar.setText("error: "+e.getMessage());
		}
	}
	
	public void receive(int[] binary){
		if(binary[4]==8){
			//structure "WriteRegister"
			int value = binary[10]+binary[11]*256;
			for(int i=0;i<outputs;i++){
				if((value & (int)Math.pow(2,i)) >0){
					cb_inputs[i].setSelected(true);
				}else{
					cb_inputs[i].setSelected(false);
				}
			}
		}else if(binary[4]==49){
			//structure "RegisterState"
			int value = binary[12] + binary[13]*256; 
			for(int i=0;i<outputs;i++){
				if((value & (int)Math.pow(2,i)) > 0){
					cb_outputs[i].setSelected(true);
				}else{
					cb_outputs[i].setSelected(false);
				}
			}
		}else if(binary[4]==180){
			//structure "Counter"
			int counter_value= binary[10]+ (binary[11]*256)+(binary[12]*65536)*(binary[13]*16777216);
			tf_counter[binary[8]].setText(counter_value+"");
		}else if(binary[4]==181){
			//structure "AllCounter"
			for(int i=0; i<inputs;i++){
				int counter_value= binary[(i*4+10)]+ (binary[(i*4+11)]*256)+(binary[(i*4+12)]*65536)+(binary[(i*4+13)]*16777216);
				tf_counter[i].setText(counter_value+"");
			}
		}
	}
	public void run()
	{
		int buffer[] = new int[64];
		int stop=8;
		int i=0;
		try {
		   int sign;
		   while ((sign = in.read()) != -1) { 
			   	buffer[i]= sign;
		   		if(i==6){ stop = (int)buffer[i]-1;}
		   		if(i == stop){
			   		this.receive(buffer);
			   		i=-1;
		   		}
		   		i++;
		   }  
		}catch (IOException e) {
			tf_statusbar.setText("error: "+e.getMessage());
		}
		tf_statusbar.setText("");
		this.disconnect();
		   
	}
	public static void main(String[] args) {
		new WebIO_Binary_Client_2_2("Web-IO Binary Client");
	}
}